abuild.in 26.8 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
74 75

	
Linux User's avatar
Linux User committed
76 77
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
97
	local i
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
111 112 113 114 115 116 117
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

118 119
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
120 121 122 123
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
124
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
125 126 127
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
128 129
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
130

131 132
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
133
			source_has $i || die "$i exists in md5sums but is missing in source"
134 135
		done
	fi
136

137 138 139
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
140 141

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
142 143

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
144 145 146 147
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
148
	local dummy f
149 150 151
	if [ -z "$source" ]; then
		return 0
	fi
152
	if [ -z "$md5sums" ]; then
153
		die "Use 'abuild checksum' to generate/update the checksum(s)"
154
	fi
155 156 157
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
158
	fetch || return 1
159
	msg "Checking md5sums..."
160
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
161 162 163 164
}

uri_fetch() {
	local uri="$1"
165
	local d="${uri##*/}"	# $(basename $uri)
166 167 168 169
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

170 171 172 173 174
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
175
	mkdir -p "$SRCDEST"
176 177 178
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
179
	fi
Linux User's avatar
Linux User committed
180
	msg "Fetching $uri"
181 182
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
183 184
}

185 186
is_remote() {
	case "$1" in
187
		http://*|ftp://*|https://*)
188 189 190 191 192
			return 0;;
	esac
	return 1
}

193 194 195 196 197
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
198 199 200 201 202
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
203 204 205 206
	fi
	uri_fetch "$uri"
}

207
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
208 209
	local s
	mkdir -p "$srcdir"
210 211
	for s in $source; do
		if is_remote "$s"; then
212
			uri_fetch_mirror "$s" || return 1
213 214 215 216
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
217 218 219
	done
}

220 221 222 223
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
224
# unpack the sources
225
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
226
	local u
227
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
228 229 230 231
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
232
			*.tar.gz|*.tgz)
233
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
234 235
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
236
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
237
				tar -C "$srcdir" -jxf "$s" || return 1;;
238 239 240 241
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
242 243 244
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
245 246 247
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
248 249 250 251
		esac
	done
}

252 253 254 255
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
256 257
# cleanup source and package dir
clean() {
258
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
259
	rm -rf "$srcdir"
260
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
261 262 263 264 265 266
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
267 268 269 270
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
271 272 273 274 275
	done
}

cleanpkg() {
	local i
276
	getpkgver || return 1
277
	msg "Cleaning built packages..."
278
	for i in $pkgname $subpackages; do
279 280
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
281
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
282
	done
283
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
284 285
}

286 287 288
# clean all packages except current
cleanoldpkg() {
	local i j
289
	getpkgver || return 1
290 291 292 293 294 295 296 297 298
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
317 318
runpart() {
	local part=$1
319
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
320 321 322 323
	$part || die "$part failed"
}

# override those in your build script
324 325 326 327 328 329 330 331
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
332 333 334 335
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
336
build() {
337
	:
Natanael Copa's avatar
Natanael Copa committed
338 339
}

340 341 342 343 344 345
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

346 347 348 349 350 351 352 353 354
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

355
prepare_subpackages() {
356
	if [ -z "$subpackages" ]; then
357 358
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
359 360
	local i
	cd "$startdir"
361
	for i in $subpackages; do
362 363
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
364
		msg "Running split function $func..."
365
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
366
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
367 368 369
	done
}

370
prepare_metafiles() {
371
	getpkgver || return 1
372 373
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
374
	local dir=${subpkgdir:-$pkgdir}
375
	local pkg="$name-$pkgver-r$pkgrel.apk"
376
	local pkginfo="$controldir"/.PKGINFO
377
	local sub
Natanael Copa's avatar
Natanael Copa committed
378 379 380
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
381
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
382 383 384
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

385
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
386
	if [ -n "$FAKEROOTKEY" ]; then
387
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
388
	fi
389 390
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
391
pkgname = $name
392
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
393 394 395 396 397 398
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
399 400
	local i deps
	deps="$depends"
401
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
402 403
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
404 405 406 407 408
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
409 410
	fi
	
Natanael Copa's avatar
Natanael Copa committed
411
	for i in $license; do
412
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
413 414
	done
	for i in $replaces; do
415
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
416
	done
417
	for i in $deps; do
418
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
419 420
	done
	for i in $conflicts; do
421
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
422 423
	done
	for i in $provides; do
424
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
425 426
	done
	for i in $backup; do
427
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
428
	done
Natanael Copa's avatar
Natanael Copa committed
429 430 431
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
432 433

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
434
	for i in $install ${triggers%%:*}; do
435 436
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
437
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
438 439
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
440
			*) 	error "$script: Invalid install/trigger script"
441 442 443
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
444
		cp "$startdir/$i" "$controldir/$script" || return 1
445
		chmod +x "$controldir/$script"
446 447
		metafiles="$metafiles $script"
	done
448
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
449
}
450

451 452 453
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
454 455
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
456
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
457 458 459
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
460 461
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
462
	done
Natanael Copa's avatar
Natanael Copa committed
463 464
}

465
prepare_package() {
466
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
467
	stripbin
468
	prepare_metafiles && prepare_tracedeps
469 470 471 472 473 474 475 476
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

477 478 479
trace_apk_deps() {
	local name="$1"
	local dir="$2"
480 481
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
482 483 484 485 486 487
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
		msg "Added pkgconfig as dependency"
		echo "depend = pkgconfig" >> "$dir"/.PKGINFO
	fi
488
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
489
		found=
490
		# first check if its provide by same apkbuild
491
		for j in "$dir"/../.control.*/.provides-so; do
492
			grep -w "$i" "$j" >/dev/null || continue
493
			found=${j%/.provides-so}
494
			found=${found##*/.control.}
495
			break
496 497 498
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
499
			found=$($APK info -q -W /lib/$i /usr/lib/$i)
500 501 502 503 504
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
505
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
506 507 508
			warning "You can remove '$found' from depends"
			continue
		fi
509 510
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
511 512 513 514 515 516 517 518
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

519 520
create_apks() {
	local file
521
	getpkgver || return 1
522
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
523 524 525
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
526
		local apk=$name-$ver.apk
527
		local datadir="$pkgbasedir"/$name
528 529

		trace_apk_deps "$name" "$dir" || return 1
530
		msg "Creating $apk..."
531
		(
532 533
		cd "$datadir"
		# data.tar.gz
534 535 536 537 538 539
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
540 541 542 543 544 545

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
546
		cd "$dir"
547 548
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
549
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
550

551 552 553
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
554 555 556
	done
}

557
update_abuildrepo() {
558
	if ! apk_up2date || [ -n "$force" ]; then
559
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
560
			&& prepare && mkusers && rootpkg || return 1
561
	fi
562

563
	local apk
564 565
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
566 567 568 569 570 571 572 573 574

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
575
	for apk in $(listpkg); do
576
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
577 578
	done

579
	msg "Updating the cached abuild repository index..."
580 581 582 583 584
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
585
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
586 587
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
588 589 590
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
591
	chmod 644 APKINDEX.tar.gz
592 593
}

594
# predefined splitfunc doc
595
default_doc() {
596
	depends="$depends_doc"
597
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
598
	triggers="$triggers_doc"
Natanael Copa's avatar
Natanael Copa committed
599
	local i
600
	for i in doc man info html sgml licenses gtk-doc; do
601 602 603
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
604 605
		fi
	done
606 607 608
	
	rm -f "$subpkgdir/usr/share/info/dir"

609 610 611
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
612 613 614 615

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
616
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
617 618 619
	return 0
}

620 621 622 623
doc() {
	default_doc
}

624
# predefined splitfunc mod
625
default_mod() {
626
	depends="$kernel $depends_mod"
627
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
628
	for i in firmware modules; do
629 630 631
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
632
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
633 634 635 636
		fi
	done
}

637 638 639 640
mod() {
	default_mod
}

641
# predefined splitfunc dev
642
default_dev() {
643
	local i= j=
644
	depends="$pkgname $depends_dev"
645
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
646
	triggers="$triggers_dev"
647 648 649 650
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
651
	cd "$pkgdir" || return 0
652 653
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
654
			usr/share/vala/vapi usr/share/gir-[0-9]*\
655 656 657
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
658 659
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
660
			mkdir -p "$d"
661
			mv "$pkgdir/$i" "$d"
662
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
663 664
		fi
	done
665 666 667 668 669 670 671
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
672
	return 0
Natanael Copa's avatar
Natanael Copa committed
673 674
}

675 676 677 678
dev() {
	default_dev
}

679 680 681 682
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
683 684
# build and package in fakeroot
rootpkg() {
685 686 687 688
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
689
		do_build=package
690
	fi
Natanael Copa's avatar
Natanael Copa committed
691
	cd "$startdir"
692
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
693
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
694 695
		prepare_subpackages \
		prepare_package \
696
		create_apks
Natanael Copa's avatar
Natanael Copa committed
697 698 699
}

srcpkg() {
700
	getpkgver || return 1
701
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
702
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
703 704 705 706 707
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
708
	msg "Creating source package $p.src.tar.gz..."
709
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
710 711
}

712
# check if package is up to date
713
apk_up2date() {
714
	getpkgver || return 1
715
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
716
	local i s
Natanael Copa's avatar
Natanael Copa committed
717
	cd "$startdir"
718 719 720 721 722
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

723
	for i in $source APKBUILD; do
724 725 726 727 728 729
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
730 731 732 733 734 735 736
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

737
abuildindex_up2date() {
738
	local i apk
739
	getpkgver || return 1
740 741
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
742
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
743 744 745 746 747
	done
	return 0
}

up2date() {
748 749 750 751 752 753 754
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
755 756
}

757 758 759 760 761 762 763
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
764 765
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
766 767 768 769
		pkgname=
		subpackages=
		depends=
		makedepends=
770
		. $i
771
		dir=${i%/APKBUILD}
772
		deps=
773
		# filter out conflicts from deps and version info
774 775 776 777
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
778
			deps="$deps ${j%%[<>=]*}"
779
		done
780
		for j in $pkgname $subpackages; do
781
			echo "o ${j%%:*} $dir"
782
			set -- $deps
783 784 785 786 787 788 789
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
790 791
		done
	done
792
	)
793 794
}

795
deptrace() {
796 797 798
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
799
		deps="$deps ${i%%[<>=]*}"
800
	done
801
	[ -z "$deps" ] && return 0
802 803 804
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
805
			$APK info -q | sort |  sed 's/^/i /'
806
		fi
807
	) | awk -v pkgs="$deps" '
808 809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
833
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
834
	local filtered_deps= conflicts=
835
	[ -n "$nodeps" ] && return 0
836
	msg "Analyzing dependencies..."
837

838 839 840
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
841
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
842 843
	done

844
	installed_deps=$($APK info -e $deps)
845
	# find which deps are missing
846
	for i in $deps; do
847
		if [ "${i#\!}" != "$i" ]; then
848
			$APK info -q -e "${i#\!}" \
849
				&& conflicts="$conflicts ${i#\!}"
850
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
851 852 853
			missing="$missing $i"
		fi
	done
854
	
855
	if [ -n "$conflicts" ]; then
856 857
		error "Conflicting package(s) installed:$conflicts"
		return 1
858 859 860 861 862 863 864 865
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
866

867
	uninstall_after=".makedepends-$pkgname $uninstall_after"
868
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
869 870
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
871
		$SUDO $APK add --repository "$abuildrepo" \
872 873
			--wait 30 \
			--simulate --quiet $deps || return 1
874
		$SUDO $APK add --repository "$abuildrepo" \
875
			--wait 30 \
876 877
			--virtual .makedepends-$pkgname $deps \
			&& return 0
878
	fi
879 880
	
	[ -z "$recursive" ] && return 1
881 882 883

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
884
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
885
		if [ -z "$m" ]; then
886 887 888
			missing="$missing $i"
		fi
	done
889 890
	
	for i in $(deptrace $missing); do
891 892 893
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
894 895 896 897 898 899 900 901 902 903

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
904
			$recursive $upgrade $color_opt abuildindex || return 1
905
	done
906
	$SUDO $APK add -u --repository "$abuildrepo" \
907
		--wait 30 \
908
		--virtual .makedepends-$pkgname $deps
909 910
}

911
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
912 913
checksum() {
	local s files
914
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
915
	fetch
916
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
917 918 919 920
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
921 922
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
923 924
}

925
stripbin() {
926
	local bin
927
	options_has "!strip" && return 0
928 929
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
930 931 932
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
933 934
}

935 936 937
# simply list target apks
listpkg() {
	local i 
938
	getpkgver || return 1
939 940 941 942 943
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
944 945 946 947 948 949 950 951
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
952 953 954 955 956 957 958 959
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

960 961 962 963 964 965 966 967 968 969 970
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

971 972 973 974 975 976
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
977
		i=${i%%[<>=]*}
978 979 980 981 982 983
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

984 985 986 987
options_has() {
	list_has "$1" $options
}

988
depends_has() {
989
	deplist_has "$1" $depends
990 991
}

992
makedepends_has() {
993
	deplist_has "$1" $makedepends
994 995
}

Natanael Copa's avatar
Natanael Copa committed
996 997 998 999
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
1000 1001 1002 1003
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
Natanael Copa committed
1004 1005
# install package after build
post_add() {
1006
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1007 1008 1009 1010 1011 1012
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
1013
	deps=$($APK index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
Natanael Copa's avatar
Natanael Copa committed
1014 1015 1016 1017 1018
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
1019
	$SUDO $APK add --wait 30 -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
Natanael Copa committed
1020 1021
}

1022
installdeps() {
1023
	local deps i
1024
	sudo $APK add --wait 30 --repository "$abuildrepo" \
1025
		--virtual .makedepends-$pkgname \
1026
		$makedepends
1027 1028 1029
}

uninstalldeps (){
1030
	sudo $APK del .makedepends-$pkgname
1031
}
1032 1033 1034 1035 1036

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
1037
		update_abuildrepo
1038 1039 1040
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1041
usage() {
1042 1043
	echo "$program $abuild_ver"
	echo "usage: $program [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
1044
	echo "              [-s SRCDEST] [cmd] ..."
1045
	echo "       $program [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
1046
	echo "Options:"
1047
	echo " -c  Enable colored output"
1048
	echo " -d  Disable dependency checking"
Natanael Copa's avatar
Natanael Copa committed
1049
	echo " -f  Force specified cmd, even if they are already done"
1050
	echo " -F  Force run as root"
1051 1052
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
1053
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
1054
	echo " -m  Disable colors (monochrome)"
1055
	echo " -p  Set package destination directory"
1056
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
1057
	echo " -q  Quiet"
1058 1059
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
1060
	echo " -s  Set source package destination directory"
1061
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
1062 1063
	echo ""
	echo "Commands:"
1064
	echo "  checksum    Generate checksum to be included in APKBUILD"
1065 1066 1067 1068 1069
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
1070
	echo "  listpkg     List target packages"
1071 1072 1073
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
1074
	echo "  cleanoldpkg Remove binary packages except current version"
1075 1076 1077 1078
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
1079 1080
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
1081 1082 1083 1084 1085
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"